import { Country, CountryWrite, CountryWritePatch, WrappedCountry, WrappedWithMetaArrayCountry } from "../api";
import { FindQueryParams, GetQueryParams } from "../model/queryParams";
import { Auth } from "./auth";
export declare class CountriesClient {
    private client;
    constructor(basePath: string, auth: Auth);
    create(country: CountryWrite): Promise<WrappedCountry>;
    get(id: string, query?: GetQueryParams): Promise<WrappedCountry>;
    find(findParams?: FindQueryParams<Country>): Promise<WrappedWithMetaArrayCountry>;
    patch(id: string, country: CountryWritePatch): Promise<WrappedCountry>;
}
