import { AxiosResponse } from "axios";
import { ErrorData } from "./errorData";
import { ErrorDetails } from "./errorDetails";
export declare class CoreApiError extends Error {
    details: ErrorDetails;
    httpResponse?: AxiosResponse;
    constructor(err: ErrorData, httpResponse?: AxiosResponse);
    get isCoreApiError(): boolean;
    static fromHttpResponse(res: AxiosResponse): CoreApiError;
}
