export * from './address';
export * from './affiliation';
export * from './affiliationType';
export * from './affiliationWrite';
export * from './affiliationWritePatch';
export * from './consent';
export * from './consentPurpose';
export * from './consentWrite';
export * from './consentWritePatch';
export * from './country';
export * from './countryWrite';
export * from './countryWritePatch';
export * from './errorCode';
export * from './errorData';
export * from './errorDetails';
export * from './gender';
export * from './maritalStatus';
export * from './metadata';
export * from './nationalId';
export * from './org';
export * from './orgActiveStatus';
export * from './orgType';
export * from './orgWrite';
export * from './orgWritePatch';
export * from './person';
export * from './personRelation';
export * from './personRelationType';
export * from './personWrite';
export * from './personWritePatch';
export * from './preferences';
export * from './preferencesPatch';
export * from './relation';
export * from './relationType';
export * from './relationWrite';
export * from './relationWritePatch';
export * from './role';
export * from './roleAssignment';
export * from './roleAssignmentWrite';
export * from './roleAssignmentWritePatch';
export * from './roleScope';
export * from './roleWrite';
export * from './searchVisibility';
export * from './visibilityPreferences';
export * from './visibilityPreferencesPatch';
export * from './wrappedAffiliation';
export * from './wrappedConsent';
export * from './wrappedCountry';
export * from './wrappedOrg';
export * from './wrappedPerson';
export * from './wrappedRelation';
export * from './wrappedRole';
export * from './wrappedRoleAssignment';
export * from './wrappedWithMetaArrayAffiliation';
export * from './wrappedWithMetaArrayConsent';
export * from './wrappedWithMetaArrayCountry';
export * from './wrappedWithMetaArrayOrg';
export * from './wrappedWithMetaArrayPerson';
export * from './wrappedWithMetaArrayRelation';
export * from './wrappedWithMetaArrayRole';
export * from './wrappedWithMetaArrayRoleAssignment';
import { Address } from './address';
import { Affiliation } from './affiliation';
import { AffiliationType } from './affiliationType';
import { AffiliationWrite } from './affiliationWrite';
import { AffiliationWritePatch } from './affiliationWritePatch';
import { Consent } from './consent';
import { ConsentPurpose } from './consentPurpose';
import { ConsentWrite } from './consentWrite';
import { ConsentWritePatch } from './consentWritePatch';
import { Country } from './country';
import { CountryWrite } from './countryWrite';
import { CountryWritePatch } from './countryWritePatch';
import { ErrorCode } from './errorCode';
import { ErrorData } from './errorData';
import { ErrorDetails } from './errorDetails';
import { Gender } from './gender';
import { MaritalStatus } from './maritalStatus';
import { Metadata } from './metadata';
import { NationalId } from './nationalId';
import { Org } from './org';
import { OrgActiveStatus } from './orgActiveStatus';
import { OrgType } from './orgType';
import { OrgWrite } from './orgWrite';
import { OrgWritePatch } from './orgWritePatch';
import { Person } from './person';
import { PersonRelation } from './personRelation';
import { PersonRelationType } from './personRelationType';
import { PersonWrite } from './personWrite';
import { PersonWritePatch } from './personWritePatch';
import { Preferences } from './preferences';
import { PreferencesPatch } from './preferencesPatch';
import { Relation } from './relation';
import { RelationType } from './relationType';
import { RelationWrite } from './relationWrite';
import { RelationWritePatch } from './relationWritePatch';
import { Role } from './role';
import { RoleAssignment } from './roleAssignment';
import { RoleAssignmentWrite } from './roleAssignmentWrite';
import { RoleAssignmentWritePatch } from './roleAssignmentWritePatch';
import { RoleScope } from './roleScope';
import { RoleWrite } from './roleWrite';
import { SearchVisibility } from './searchVisibility';
import { VisibilityPreferences } from './visibilityPreferences';
import { VisibilityPreferencesPatch } from './visibilityPreferencesPatch';
import { WrappedAffiliation } from './wrappedAffiliation';
import { WrappedConsent } from './wrappedConsent';
import { WrappedCountry } from './wrappedCountry';
import { WrappedOrg } from './wrappedOrg';
import { WrappedPerson } from './wrappedPerson';
import { WrappedRelation } from './wrappedRelation';
import { WrappedRole } from './wrappedRole';
import { WrappedRoleAssignment } from './wrappedRoleAssignment';
import { WrappedWithMetaArrayAffiliation } from './wrappedWithMetaArrayAffiliation';
import { WrappedWithMetaArrayConsent } from './wrappedWithMetaArrayConsent';
import { WrappedWithMetaArrayCountry } from './wrappedWithMetaArrayCountry';
import { WrappedWithMetaArrayOrg } from './wrappedWithMetaArrayOrg';
import { WrappedWithMetaArrayPerson } from './wrappedWithMetaArrayPerson';
import { WrappedWithMetaArrayRelation } from './wrappedWithMetaArrayRelation';
import { WrappedWithMetaArrayRole } from './wrappedWithMetaArrayRole';
import { WrappedWithMetaArrayRoleAssignment } from './wrappedWithMetaArrayRoleAssignment';
let primitives = [
    "string",
    "boolean",
    "double",
    "integer",
    "long",
    "float",
    "number",
    "any"
];
let enumsMap = {
    "AffiliationType": AffiliationType,
    "ConsentPurpose": ConsentPurpose,
    "ErrorCode": ErrorCode,
    "Gender": Gender,
    "MaritalStatus": MaritalStatus,
    "OrgActiveStatus": OrgActiveStatus,
    "OrgType": OrgType,
    "PersonRelationType": PersonRelationType,
    "RelationType": RelationType,
    "RoleScope": RoleScope,
    "SearchVisibility": SearchVisibility,
};
let typeMap = {
    "Address": Address,
    "Affiliation": Affiliation,
    "AffiliationWrite": AffiliationWrite,
    "AffiliationWritePatch": AffiliationWritePatch,
    "Consent": Consent,
    "ConsentWrite": ConsentWrite,
    "ConsentWritePatch": ConsentWritePatch,
    "Country": Country,
    "CountryWrite": CountryWrite,
    "CountryWritePatch": CountryWritePatch,
    "ErrorData": ErrorData,
    "ErrorDetails": ErrorDetails,
    "Metadata": Metadata,
    "NationalId": NationalId,
    "Org": Org,
    "OrgWrite": OrgWrite,
    "OrgWritePatch": OrgWritePatch,
    "Person": Person,
    "PersonRelation": PersonRelation,
    "PersonWrite": PersonWrite,
    "PersonWritePatch": PersonWritePatch,
    "Preferences": Preferences,
    "PreferencesPatch": PreferencesPatch,
    "Relation": Relation,
    "RelationWrite": RelationWrite,
    "RelationWritePatch": RelationWritePatch,
    "Role": Role,
    "RoleAssignment": RoleAssignment,
    "RoleAssignmentWrite": RoleAssignmentWrite,
    "RoleAssignmentWritePatch": RoleAssignmentWritePatch,
    "RoleWrite": RoleWrite,
    "VisibilityPreferences": VisibilityPreferences,
    "VisibilityPreferencesPatch": VisibilityPreferencesPatch,
    "WrappedAffiliation": WrappedAffiliation,
    "WrappedConsent": WrappedConsent,
    "WrappedCountry": WrappedCountry,
    "WrappedOrg": WrappedOrg,
    "WrappedPerson": WrappedPerson,
    "WrappedRelation": WrappedRelation,
    "WrappedRole": WrappedRole,
    "WrappedRoleAssignment": WrappedRoleAssignment,
    "WrappedWithMetaArrayAffiliation": WrappedWithMetaArrayAffiliation,
    "WrappedWithMetaArrayConsent": WrappedWithMetaArrayConsent,
    "WrappedWithMetaArrayCountry": WrappedWithMetaArrayCountry,
    "WrappedWithMetaArrayOrg": WrappedWithMetaArrayOrg,
    "WrappedWithMetaArrayPerson": WrappedWithMetaArrayPerson,
    "WrappedWithMetaArrayRelation": WrappedWithMetaArrayRelation,
    "WrappedWithMetaArrayRole": WrappedWithMetaArrayRole,
    "WrappedWithMetaArrayRoleAssignment": WrappedWithMetaArrayRoleAssignment,
};
export class ObjectSerializer {
    static findCorrectType(data, expectedType) {
        if (data == undefined) {
            return expectedType;
        }
        else if (primitives.indexOf(expectedType.toLowerCase()) !== -1) {
            return expectedType;
        }
        else if (expectedType === "Date") {
            return expectedType;
        }
        else {
            if (enumsMap[expectedType]) {
                return expectedType;
            }
            if (!typeMap[expectedType]) {
                return expectedType;
            }
            let discriminatorProperty = typeMap[expectedType].discriminator;
            if (discriminatorProperty == null) {
                return expectedType;
            }
            else {
                if (data[discriminatorProperty]) {
                    var discriminatorType = data[discriminatorProperty];
                    if (typeMap[discriminatorType]) {
                        return discriminatorType;
                    }
                    else {
                        return expectedType;
                    }
                }
                else {
                    return expectedType;
                }
            }
        }
    }
    static serialize(data, type) {
        if (data == undefined) {
            return data;
        }
        else if (primitives.indexOf(type.toLowerCase()) !== -1) {
            return data;
        }
        else if (type.lastIndexOf("Array<", 0) === 0) {
            let subType = type.replace("Array<", "");
            subType = subType.substring(0, subType.length - 1);
            let transformedData = [];
            for (let index = 0; index < data.length; index++) {
                let datum = data[index];
                transformedData.push(ObjectSerializer.serialize(datum, subType));
            }
            return transformedData;
        }
        else if (type === "Date") {
            return data.toISOString();
        }
        else {
            if (enumsMap[type]) {
                return data;
            }
            if (!typeMap[type]) {
                return data;
            }
            type = this.findCorrectType(data, type);
            let attributeTypes = typeMap[type].getAttributeTypeMap();
            let instance = {};
            for (let index = 0; index < attributeTypes.length; index++) {
                let attributeType = attributeTypes[index];
                instance[attributeType.baseName] = ObjectSerializer.serialize(data[attributeType.name], attributeType.type);
            }
            return instance;
        }
    }
    static deserialize(data, type) {
        type = ObjectSerializer.findCorrectType(data, type);
        if (data == undefined) {
            return data;
        }
        else if (primitives.indexOf(type.toLowerCase()) !== -1) {
            return data;
        }
        else if (type.lastIndexOf("Array<", 0) === 0) {
            let subType = type.replace("Array<", "");
            subType = subType.substring(0, subType.length - 1);
            let transformedData = [];
            for (let index = 0; index < data.length; index++) {
                let datum = data[index];
                transformedData.push(ObjectSerializer.deserialize(datum, subType));
            }
            return transformedData;
        }
        else if (type === "Date") {
            return new Date(data);
        }
        else {
            if (enumsMap[type]) {
                return data;
            }
            if (!typeMap[type]) {
                return data;
            }
            let instance = new typeMap[type]();
            let attributeTypes = typeMap[type].getAttributeTypeMap();
            for (let index = 0; index < attributeTypes.length; index++) {
                let attributeType = attributeTypes[index];
                instance[attributeType.name] = ObjectSerializer.deserialize(data[attributeType.baseName], attributeType.type);
            }
            return instance;
        }
    }
}
export class HttpBasicAuth {
    constructor() {
        this.username = '';
        this.password = '';
    }
    applyToRequest(requestOptions) {
        requestOptions.auth = {
            username: this.username, password: this.password
        };
    }
}
export class HttpBearerAuth {
    constructor() {
        this.accessToken = '';
    }
    applyToRequest(requestOptions) {
        if (requestOptions && requestOptions.headers) {
            const accessToken = typeof this.accessToken === 'function'
                ? this.accessToken()
                : this.accessToken;
            requestOptions.headers["Authorization"] = "Bearer " + accessToken;
        }
    }
}
export class ApiKeyAuth {
    constructor(location, paramName) {
        this.location = location;
        this.paramName = paramName;
        this.apiKey = '';
    }
    applyToRequest(requestOptions) {
        if (this.location == "query") {
            requestOptions.qs[this.paramName] = this.apiKey;
        }
        else if (this.location == "header" && requestOptions && requestOptions.headers) {
            requestOptions.headers[this.paramName] = this.apiKey;
        }
        else if (this.location == 'cookie' && requestOptions && requestOptions.headers) {
            if (requestOptions.headers['Cookie']) {
                requestOptions.headers['Cookie'] += '; ' + this.paramName + '=' + encodeURIComponent(this.apiKey);
            }
            else {
                requestOptions.headers['Cookie'] = this.paramName + '=' + encodeURIComponent(this.apiKey);
            }
        }
    }
}
export class OAuth {
    constructor() {
        this.accessToken = '';
    }
    applyToRequest(requestOptions) {
        if (requestOptions && requestOptions.headers) {
            requestOptions.headers["Authorization"] = "Bearer " + this.accessToken;
        }
    }
}
export class VoidAuth {
    constructor() {
        this.username = '';
        this.password = '';
    }
    applyToRequest(_) {
    }
}
