import { Person } from './person';
import { RelationType } from './relationType';
export declare class Relation {
    'lastChangedDate': Date;
    'origin'?: Person;
    'originUid': string;
    'target'?: Person;
    'targetUid': string;
    'type': RelationType;
    'uid': string;
    'validFrom': Date;
    'validTo'?: Date;
    static discriminator: string | undefined;
    static attributeTypeMap: Array<{
        name: string;
        baseName: string;
        type: string;
    }>;
    static getAttributeTypeMap(): {
        name: string;
        baseName: string;
        type: string;
    }[];
}
