import { Role, RoleWrite, WrappedRole, WrappedWithMetaArrayRole } from "../api";
import { FindQueryParams, GetQueryParams } from "../model/queryParams";
import { Auth } from "./auth";
export declare class RolesClient {
    private client;
    constructor(basePath: string, auth: Auth);
    create(org: RoleWrite): Promise<WrappedRole>;
    get(id: string, query?: GetQueryParams): Promise<WrappedRole>;
    find(findParams?: FindQueryParams<Role>): Promise<WrappedWithMetaArrayRole>;
}
