export declare enum Environment {
    Prod = 0,
    Sandbox = 1,
    Dev = 2,
    Emulator = 3
}
export interface EnvironmentConfig {
    apiBaseUrl: string;
    tokenUrl: string;
    oauthAudience: string;
}
export declare const defaultEnvironmentConfig: Record<Environment, EnvironmentConfig>;
