"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.VoidAuth = exports.OAuth = exports.ApiKeyAuth = exports.HttpBearerAuth = exports.HttpBasicAuth = exports.ObjectSerializer = void 0;
__exportStar(require("./address"), exports);
__exportStar(require("./affiliation"), exports);
__exportStar(require("./affiliationType"), exports);
__exportStar(require("./affiliationWrite"), exports);
__exportStar(require("./affiliationWritePatch"), exports);
__exportStar(require("./consent"), exports);
__exportStar(require("./consentPurpose"), exports);
__exportStar(require("./consentWrite"), exports);
__exportStar(require("./consentWritePatch"), exports);
__exportStar(require("./country"), exports);
__exportStar(require("./countryWrite"), exports);
__exportStar(require("./countryWritePatch"), exports);
__exportStar(require("./errorCode"), exports);
__exportStar(require("./errorData"), exports);
__exportStar(require("./errorDetails"), exports);
__exportStar(require("./gender"), exports);
__exportStar(require("./maritalStatus"), exports);
__exportStar(require("./metadata"), exports);
__exportStar(require("./nationalId"), exports);
__exportStar(require("./org"), exports);
__exportStar(require("./orgActiveStatus"), exports);
__exportStar(require("./orgType"), exports);
__exportStar(require("./orgWrite"), exports);
__exportStar(require("./orgWritePatch"), exports);
__exportStar(require("./person"), exports);
__exportStar(require("./personRelation"), exports);
__exportStar(require("./personRelationType"), exports);
__exportStar(require("./personWrite"), exports);
__exportStar(require("./personWritePatch"), exports);
__exportStar(require("./preferences"), exports);
__exportStar(require("./preferencesPatch"), exports);
__exportStar(require("./relation"), exports);
__exportStar(require("./relationType"), exports);
__exportStar(require("./relationWrite"), exports);
__exportStar(require("./relationWritePatch"), exports);
__exportStar(require("./role"), exports);
__exportStar(require("./roleAssignment"), exports);
__exportStar(require("./roleAssignmentWrite"), exports);
__exportStar(require("./roleAssignmentWritePatch"), exports);
__exportStar(require("./roleScope"), exports);
__exportStar(require("./roleWrite"), exports);
__exportStar(require("./searchVisibility"), exports);
__exportStar(require("./visibilityPreferences"), exports);
__exportStar(require("./visibilityPreferencesPatch"), exports);
__exportStar(require("./wrappedAffiliation"), exports);
__exportStar(require("./wrappedConsent"), exports);
__exportStar(require("./wrappedCountry"), exports);
__exportStar(require("./wrappedOrg"), exports);
__exportStar(require("./wrappedPerson"), exports);
__exportStar(require("./wrappedRelation"), exports);
__exportStar(require("./wrappedRole"), exports);
__exportStar(require("./wrappedRoleAssignment"), exports);
__exportStar(require("./wrappedWithMetaArrayAffiliation"), exports);
__exportStar(require("./wrappedWithMetaArrayConsent"), exports);
__exportStar(require("./wrappedWithMetaArrayCountry"), exports);
__exportStar(require("./wrappedWithMetaArrayOrg"), exports);
__exportStar(require("./wrappedWithMetaArrayPerson"), exports);
__exportStar(require("./wrappedWithMetaArrayRelation"), exports);
__exportStar(require("./wrappedWithMetaArrayRole"), exports);
__exportStar(require("./wrappedWithMetaArrayRoleAssignment"), exports);
const address_1 = require("./address");
const affiliation_1 = require("./affiliation");
const affiliationType_1 = require("./affiliationType");
const affiliationWrite_1 = require("./affiliationWrite");
const affiliationWritePatch_1 = require("./affiliationWritePatch");
const consent_1 = require("./consent");
const consentPurpose_1 = require("./consentPurpose");
const consentWrite_1 = require("./consentWrite");
const consentWritePatch_1 = require("./consentWritePatch");
const country_1 = require("./country");
const countryWrite_1 = require("./countryWrite");
const countryWritePatch_1 = require("./countryWritePatch");
const errorCode_1 = require("./errorCode");
const errorData_1 = require("./errorData");
const errorDetails_1 = require("./errorDetails");
const gender_1 = require("./gender");
const maritalStatus_1 = require("./maritalStatus");
const metadata_1 = require("./metadata");
const nationalId_1 = require("./nationalId");
const org_1 = require("./org");
const orgActiveStatus_1 = require("./orgActiveStatus");
const orgType_1 = require("./orgType");
const orgWrite_1 = require("./orgWrite");
const orgWritePatch_1 = require("./orgWritePatch");
const person_1 = require("./person");
const personRelation_1 = require("./personRelation");
const personRelationType_1 = require("./personRelationType");
const personWrite_1 = require("./personWrite");
const personWritePatch_1 = require("./personWritePatch");
const preferences_1 = require("./preferences");
const preferencesPatch_1 = require("./preferencesPatch");
const relation_1 = require("./relation");
const relationType_1 = require("./relationType");
const relationWrite_1 = require("./relationWrite");
const relationWritePatch_1 = require("./relationWritePatch");
const role_1 = require("./role");
const roleAssignment_1 = require("./roleAssignment");
const roleAssignmentWrite_1 = require("./roleAssignmentWrite");
const roleAssignmentWritePatch_1 = require("./roleAssignmentWritePatch");
const roleScope_1 = require("./roleScope");
const roleWrite_1 = require("./roleWrite");
const searchVisibility_1 = require("./searchVisibility");
const visibilityPreferences_1 = require("./visibilityPreferences");
const visibilityPreferencesPatch_1 = require("./visibilityPreferencesPatch");
const wrappedAffiliation_1 = require("./wrappedAffiliation");
const wrappedConsent_1 = require("./wrappedConsent");
const wrappedCountry_1 = require("./wrappedCountry");
const wrappedOrg_1 = require("./wrappedOrg");
const wrappedPerson_1 = require("./wrappedPerson");
const wrappedRelation_1 = require("./wrappedRelation");
const wrappedRole_1 = require("./wrappedRole");
const wrappedRoleAssignment_1 = require("./wrappedRoleAssignment");
const wrappedWithMetaArrayAffiliation_1 = require("./wrappedWithMetaArrayAffiliation");
const wrappedWithMetaArrayConsent_1 = require("./wrappedWithMetaArrayConsent");
const wrappedWithMetaArrayCountry_1 = require("./wrappedWithMetaArrayCountry");
const wrappedWithMetaArrayOrg_1 = require("./wrappedWithMetaArrayOrg");
const wrappedWithMetaArrayPerson_1 = require("./wrappedWithMetaArrayPerson");
const wrappedWithMetaArrayRelation_1 = require("./wrappedWithMetaArrayRelation");
const wrappedWithMetaArrayRole_1 = require("./wrappedWithMetaArrayRole");
const wrappedWithMetaArrayRoleAssignment_1 = require("./wrappedWithMetaArrayRoleAssignment");
let primitives = [
    "string",
    "boolean",
    "double",
    "integer",
    "long",
    "float",
    "number",
    "any"
];
let enumsMap = {
    "AffiliationType": affiliationType_1.AffiliationType,
    "ConsentPurpose": consentPurpose_1.ConsentPurpose,
    "ErrorCode": errorCode_1.ErrorCode,
    "Gender": gender_1.Gender,
    "MaritalStatus": maritalStatus_1.MaritalStatus,
    "OrgActiveStatus": orgActiveStatus_1.OrgActiveStatus,
    "OrgType": orgType_1.OrgType,
    "PersonRelationType": personRelationType_1.PersonRelationType,
    "RelationType": relationType_1.RelationType,
    "RoleScope": roleScope_1.RoleScope,
    "SearchVisibility": searchVisibility_1.SearchVisibility,
};
let typeMap = {
    "Address": address_1.Address,
    "Affiliation": affiliation_1.Affiliation,
    "AffiliationWrite": affiliationWrite_1.AffiliationWrite,
    "AffiliationWritePatch": affiliationWritePatch_1.AffiliationWritePatch,
    "Consent": consent_1.Consent,
    "ConsentWrite": consentWrite_1.ConsentWrite,
    "ConsentWritePatch": consentWritePatch_1.ConsentWritePatch,
    "Country": country_1.Country,
    "CountryWrite": countryWrite_1.CountryWrite,
    "CountryWritePatch": countryWritePatch_1.CountryWritePatch,
    "ErrorData": errorData_1.ErrorData,
    "ErrorDetails": errorDetails_1.ErrorDetails,
    "Metadata": metadata_1.Metadata,
    "NationalId": nationalId_1.NationalId,
    "Org": org_1.Org,
    "OrgWrite": orgWrite_1.OrgWrite,
    "OrgWritePatch": orgWritePatch_1.OrgWritePatch,
    "Person": person_1.Person,
    "PersonRelation": personRelation_1.PersonRelation,
    "PersonWrite": personWrite_1.PersonWrite,
    "PersonWritePatch": personWritePatch_1.PersonWritePatch,
    "Preferences": preferences_1.Preferences,
    "PreferencesPatch": preferencesPatch_1.PreferencesPatch,
    "Relation": relation_1.Relation,
    "RelationWrite": relationWrite_1.RelationWrite,
    "RelationWritePatch": relationWritePatch_1.RelationWritePatch,
    "Role": role_1.Role,
    "RoleAssignment": roleAssignment_1.RoleAssignment,
    "RoleAssignmentWrite": roleAssignmentWrite_1.RoleAssignmentWrite,
    "RoleAssignmentWritePatch": roleAssignmentWritePatch_1.RoleAssignmentWritePatch,
    "RoleWrite": roleWrite_1.RoleWrite,
    "VisibilityPreferences": visibilityPreferences_1.VisibilityPreferences,
    "VisibilityPreferencesPatch": visibilityPreferencesPatch_1.VisibilityPreferencesPatch,
    "WrappedAffiliation": wrappedAffiliation_1.WrappedAffiliation,
    "WrappedConsent": wrappedConsent_1.WrappedConsent,
    "WrappedCountry": wrappedCountry_1.WrappedCountry,
    "WrappedOrg": wrappedOrg_1.WrappedOrg,
    "WrappedPerson": wrappedPerson_1.WrappedPerson,
    "WrappedRelation": wrappedRelation_1.WrappedRelation,
    "WrappedRole": wrappedRole_1.WrappedRole,
    "WrappedRoleAssignment": wrappedRoleAssignment_1.WrappedRoleAssignment,
    "WrappedWithMetaArrayAffiliation": wrappedWithMetaArrayAffiliation_1.WrappedWithMetaArrayAffiliation,
    "WrappedWithMetaArrayConsent": wrappedWithMetaArrayConsent_1.WrappedWithMetaArrayConsent,
    "WrappedWithMetaArrayCountry": wrappedWithMetaArrayCountry_1.WrappedWithMetaArrayCountry,
    "WrappedWithMetaArrayOrg": wrappedWithMetaArrayOrg_1.WrappedWithMetaArrayOrg,
    "WrappedWithMetaArrayPerson": wrappedWithMetaArrayPerson_1.WrappedWithMetaArrayPerson,
    "WrappedWithMetaArrayRelation": wrappedWithMetaArrayRelation_1.WrappedWithMetaArrayRelation,
    "WrappedWithMetaArrayRole": wrappedWithMetaArrayRole_1.WrappedWithMetaArrayRole,
    "WrappedWithMetaArrayRoleAssignment": wrappedWithMetaArrayRoleAssignment_1.WrappedWithMetaArrayRoleAssignment,
};
class ObjectSerializer {
    static findCorrectType(data, expectedType) {
        if (data == undefined) {
            return expectedType;
        }
        else if (primitives.indexOf(expectedType.toLowerCase()) !== -1) {
            return expectedType;
        }
        else if (expectedType === "Date") {
            return expectedType;
        }
        else {
            if (enumsMap[expectedType]) {
                return expectedType;
            }
            if (!typeMap[expectedType]) {
                return expectedType;
            }
            let discriminatorProperty = typeMap[expectedType].discriminator;
            if (discriminatorProperty == null) {
                return expectedType;
            }
            else {
                if (data[discriminatorProperty]) {
                    var discriminatorType = data[discriminatorProperty];
                    if (typeMap[discriminatorType]) {
                        return discriminatorType;
                    }
                    else {
                        return expectedType;
                    }
                }
                else {
                    return expectedType;
                }
            }
        }
    }
    static serialize(data, type) {
        if (data == undefined) {
            return data;
        }
        else if (primitives.indexOf(type.toLowerCase()) !== -1) {
            return data;
        }
        else if (type.lastIndexOf("Array<", 0) === 0) {
            let subType = type.replace("Array<", "");
            subType = subType.substring(0, subType.length - 1);
            let transformedData = [];
            for (let index = 0; index < data.length; index++) {
                let datum = data[index];
                transformedData.push(ObjectSerializer.serialize(datum, subType));
            }
            return transformedData;
        }
        else if (type === "Date") {
            return data.toISOString();
        }
        else {
            if (enumsMap[type]) {
                return data;
            }
            if (!typeMap[type]) {
                return data;
            }
            type = this.findCorrectType(data, type);
            let attributeTypes = typeMap[type].getAttributeTypeMap();
            let instance = {};
            for (let index = 0; index < attributeTypes.length; index++) {
                let attributeType = attributeTypes[index];
                instance[attributeType.baseName] = ObjectSerializer.serialize(data[attributeType.name], attributeType.type);
            }
            return instance;
        }
    }
    static deserialize(data, type) {
        type = ObjectSerializer.findCorrectType(data, type);
        if (data == undefined) {
            return data;
        }
        else if (primitives.indexOf(type.toLowerCase()) !== -1) {
            return data;
        }
        else if (type.lastIndexOf("Array<", 0) === 0) {
            let subType = type.replace("Array<", "");
            subType = subType.substring(0, subType.length - 1);
            let transformedData = [];
            for (let index = 0; index < data.length; index++) {
                let datum = data[index];
                transformedData.push(ObjectSerializer.deserialize(datum, subType));
            }
            return transformedData;
        }
        else if (type === "Date") {
            return new Date(data);
        }
        else {
            if (enumsMap[type]) {
                return data;
            }
            if (!typeMap[type]) {
                return data;
            }
            let instance = new typeMap[type]();
            let attributeTypes = typeMap[type].getAttributeTypeMap();
            for (let index = 0; index < attributeTypes.length; index++) {
                let attributeType = attributeTypes[index];
                instance[attributeType.name] = ObjectSerializer.deserialize(data[attributeType.baseName], attributeType.type);
            }
            return instance;
        }
    }
}
exports.ObjectSerializer = ObjectSerializer;
class HttpBasicAuth {
    constructor() {
        this.username = '';
        this.password = '';
    }
    applyToRequest(requestOptions) {
        requestOptions.auth = {
            username: this.username, password: this.password
        };
    }
}
exports.HttpBasicAuth = HttpBasicAuth;
class HttpBearerAuth {
    constructor() {
        this.accessToken = '';
    }
    applyToRequest(requestOptions) {
        if (requestOptions && requestOptions.headers) {
            const accessToken = typeof this.accessToken === 'function'
                ? this.accessToken()
                : this.accessToken;
            requestOptions.headers["Authorization"] = "Bearer " + accessToken;
        }
    }
}
exports.HttpBearerAuth = HttpBearerAuth;
class ApiKeyAuth {
    constructor(location, paramName) {
        this.location = location;
        this.paramName = paramName;
        this.apiKey = '';
    }
    applyToRequest(requestOptions) {
        if (this.location == "query") {
            requestOptions.qs[this.paramName] = this.apiKey;
        }
        else if (this.location == "header" && requestOptions && requestOptions.headers) {
            requestOptions.headers[this.paramName] = this.apiKey;
        }
        else if (this.location == 'cookie' && requestOptions && requestOptions.headers) {
            if (requestOptions.headers['Cookie']) {
                requestOptions.headers['Cookie'] += '; ' + this.paramName + '=' + encodeURIComponent(this.apiKey);
            }
            else {
                requestOptions.headers['Cookie'] = this.paramName + '=' + encodeURIComponent(this.apiKey);
            }
        }
    }
}
exports.ApiKeyAuth = ApiKeyAuth;
class OAuth {
    constructor() {
        this.accessToken = '';
    }
    applyToRequest(requestOptions) {
        if (requestOptions && requestOptions.headers) {
            requestOptions.headers["Authorization"] = "Bearer " + this.accessToken;
        }
    }
}
exports.OAuth = OAuth;
class VoidAuth {
    constructor() {
        this.username = '';
        this.password = '';
    }
    applyToRequest(_) {
    }
}
exports.VoidAuth = VoidAuth;
